package ubontransitdriver.paded.com.ubontransitdriver;

import android.app.PendingIntent;
import android.app.Service;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.location.Location;
import android.os.Bundle;
import android.os.IBinder;
import android.os.Looper;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.Manifest;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.ResultCallback;
import com.google.android.gms.common.api.Status;
import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.Geofence;
import com.google.android.gms.location.GeofencingRequest;
import com.google.android.gms.location.LocationAvailability;
import com.google.android.gms.location.LocationCallback;
import com.google.android.gms.location.LocationListener;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.location.LocationResult;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.maps.model.LatLng;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import ubontransitdriver.paded.com.ubontransitdriver.GEOFENCE.Constants;
import ubontransitdriver.paded.com.ubontransitdriver.GEOFENCE.GeofenceRegistrationService;

public class TrackerService3 extends Service implements
        GoogleApiClient.ConnectionCallbacks,
        GoogleApiClient.OnConnectionFailedListener, LocationListener {
    FusedLocationProviderClient mFusedLocationClient;
    GoogleApiClient mGoogleApiClient;
    private GoogleApiClient googleApiClient;
    LocationRequest mLocationRequest;
    String TAG = "trackService";
    private String user_id;
    private String bus_id;
    private String destination;
    private String allbusStop = "";
    private String start_busstop_id;
    private String stop_busstop_id;

    private PendingIntent pendingIntent;
    private boolean isMonitoring = false;
    private ArrayList<Geofence> mGeofenceList;
    private HashMap<String, LatLng> AREA_LANDMARKS;
    private String GEOFENCE_ID;
    private float GEOFENCE_RADIUS_IN_METERS = 50;

    private DatabaseReference database;
    private ValueEventListener eventListener1;
    private ValueEventListener eventListener2;
    DatabaseReference ref1;
    DatabaseReference ref2;

    String[] bus_stop;

    @Nullable
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        user_id = intent.getStringExtra("user_id");
        bus_id = intent.getStringExtra("bus_id");
        destination = intent.getStringExtra("destination");
        allbusStop = intent.getStringExtra("allbusStop");
        start_busstop_id = intent.getStringExtra("start_busstop_id");
        stop_busstop_id = intent.getStringExtra("stop_busstop_id");

        database = FirebaseDatabase.getInstance().getReference();

        Log.d(TAG, "onStartCommand: allbus get from intent " + allbusStop + destination);

        bus_stop = allbusStop.split(",");

        // Empty list for storing geofences.
        mGeofenceList = new ArrayList<>();
        AREA_LANDMARKS = new HashMap<String, LatLng>();

        getGeofenceList();

        addAllBusStop();

//        Log.d(TAG, "onStartCommand: "+user_id+" "+bus_id);
        mFusedLocationClient = LocationServices.getFusedLocationProviderClient(this);
        if (mGoogleApiClient != null && mFusedLocationClient != null) {
//            requestLocationUpdates();
        } else {
            buildGoogleApiClient();
        }
        return START_STICKY;
    }

    protected synchronized void buildGoogleApiClient() {
//        mGoogleApiClient = new GoogleApiClient.Builder(this)
//                .addConnectionCallbacks(this)
//                .addOnConnectionFailedListener(this)
//                .addApi(LocationServices.API)
//                .build();
//        mGoogleApiClient.connect();

        //////////////////////////////////////

        // Create Google API Client instance
        mGoogleApiClient = new GoogleApiClient.Builder(this)
                .addApi(LocationServices.API)
                .addConnectionCallbacks(this)
                .addOnConnectionFailedListener(this)
                .build();
        mGoogleApiClient.connect();
    }

    private void getGeofenceList() {
        ref1 = database.child("all_busstop");
        eventListener1 = ref1.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                for (DataSnapshot ds : dataSnapshot.getChildren()) {
                    if(Arrays.asList(bus_stop).contains(ds.getKey())){
                        getBusStopDetail(ds.getKey());
                    }else {

                    }

                }
            }
                    @Override
                    public void onCancelled (DatabaseError databaseError){

                    }
                });
    }

    public void getBusStopDetail(String itemKey) {
        ref2 = database.child("all_busstop/" + itemKey);
        eventListener2 = ref2.addValueEventListener(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
               GEOFENCE_ID = dataSnapshot.getKey();
               double lat = dataSnapshot.child("lat").getValue(Double.class);
                double lng = dataSnapshot.child("lng").getValue(Double.class);

                if(AREA_LANDMARKS.containsKey(GEOFENCE_ID)){

                }else{
                    AREA_LANDMARKS.put(GEOFENCE_ID,new LatLng(lat,lng));
                    if(AREA_LANDMARKS.size()==bus_stop.length){
//                        AREA_LANDMARKS.put("BS00",new LatLng(15.112765839672141,104.896290153265));
                        populateGeofenceList();
                        startGeofencing();
                    }

                }
            }

            @Override
            public void onCancelled(DatabaseError databaseError) {

            }
        });

    }


    private void populateGeofenceList() {
        Log.d(TAG, "populateGeofenceList: "+AREA_LANDMARKS);
        for (Map.Entry<String, LatLng> entry : AREA_LANDMARKS.entrySet()) {

            mGeofenceList.add(new Geofence.Builder()
                    // Set the request ID of the geofence. This is a string to identify this
                    // geofence.
                    .setRequestId(entry.getKey())

                    // Set the circular region of this geofence.
                    .setCircularRegion(
                            entry.getValue().latitude,
                            entry.getValue().longitude,
                            GEOFENCE_RADIUS_IN_METERS
                    )

                    // Set the expiration duration of the geofence. This geofence gets automatically
                    // removed after this period of time.
                    .setExpirationDuration(Geofence.NEVER_EXPIRE)

                    // Set the transition types of interest. Alerts are only generated for these
                    // transition. We track entry and exit transitions in this sample.
                    .setTransitionTypes(Geofence.GEOFENCE_TRANSITION_ENTER |
                            Geofence.GEOFENCE_TRANSITION_EXIT)

                    // Create the geofence.
                    .build());
        }
    }


    private PendingIntent getGeofencePendingIntent() {
        if (pendingIntent != null) {
            return pendingIntent;
        }
        Intent intent = new Intent(this, GeofenceRegistrationService.class);
        intent.putExtra("bus_stop_size", bus_stop.length);
        intent.putExtra("bus_stop_list", bus_stop);
        return PendingIntent.getService(this, 0, intent, PendingIntent.
                FLAG_UPDATE_CURRENT);
    }

    private void startGeofencing() {
        Log.d(TAG, "Start geofencing monitoring call");
        if (!mGoogleApiClient.isConnected()) {
            Log.d(TAG, "Google API client not connected");
        } else {
            try {

                LocationServices.GeofencingApi.addGeofences(mGoogleApiClient, getGeofencingRequest(), getGeofencePendingIntent()).setResultCallback(new ResultCallback<Status>() {
                    @Override
                    public void onResult(@NonNull Status status) {
                        if (status.isSuccess()) {

                            Log.d(TAG, "Successfully Geofencing Connected");
                        } else {
                            Log.d(TAG, "Failed to add Geofencing " + status.getStatus());
                        }
                    }
                });
            } catch (SecurityException e) {
                Log.d(TAG, e.getMessage());
            }
        }
        isMonitoring = true;
    }

    private GeofencingRequest getGeofencingRequest() {
        GeofencingRequest.Builder builder = new GeofencingRequest.Builder();

        // The INITIAL_TRIGGER_ENTER flag indicates that geofencing service should trigger a
        // GEOFENCE_TRANSITION_ENTER notification when the geofence is added and if the device
        // is already inside that geofence.
        builder.setInitialTrigger(GeofencingRequest.INITIAL_TRIGGER_ENTER);

        // Add the geofences to be monitored by geofencing service.
        builder.addGeofences(mGeofenceList);

        // Return a GeofencingRequest.
        return builder.build();
    }

    private void stopGeoFencing() {
        pendingIntent = getGeofencePendingIntent();
        LocationServices.GeofencingApi.removeGeofences(mGoogleApiClient, pendingIntent)
                .setResultCallback(new ResultCallback<Status>() {
                    @Override
                    public void onResult(@NonNull Status status) {
                        if (status.isSuccess())
                            Log.d(TAG, "Stop geofencing");
                        else
                            Log.d(TAG, "Not stop geofencing");
                    }
                });
        isMonitoring = false;
    }


    @Override
    public void onDestroy() {
        super.onDestroy();
        if (mFusedLocationClient != null) {
            Log.d(TAG, "Service Stop");
//            mFusedLocationClient.removeLocationUpdates(mLocationCallback);
            LocationServices.FusedLocationApi.removeLocationUpdates(mGoogleApiClient, this);
        }
    }

    public void requestLocationUpdates() {
        mLocationRequest = new LocationRequest();
        mLocationRequest.setInterval(2000); // two minute interval
        mLocationRequest.setFastestInterval(2000);
        mLocationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
        if (ContextCompat.checkSelfPermission(this,
                Manifest.permission.ACCESS_FINE_LOCATION)
                == PackageManager.PERMISSION_GRANTED) {
            mFusedLocationClient.requestLocationUpdates(mLocationRequest, mLocationCallback, Looper.myLooper());
        }
    }

    LocationCallback mLocationCallback = new LocationCallback() {

        @Override
        public void onLocationResult(LocationResult locationResult) {
//            final String path ="active_bus/"+bus_id+"/"+user_id;
            final String path = "active_bus/" + user_id;
            for (Location location : locationResult.getLocations()) {
                DatabaseReference ref = FirebaseDatabase.getInstance().getReference(path);
                ref.child("lat").setValue(location.getLatitude());
                ref.child("lng").setValue(location.getLongitude());

                Calendar c = Calendar.getInstance();
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                String formattedDate = df.format(c.getTime());

                ref.child("time").setValue(formattedDate);
                ref.child("bus_id").setValue(bus_id);

                ref.child("destination").setValue(destination);
                ref.child("start_busstop_id").setValue(start_busstop_id);
                ref.child("stop_busstop_id").setValue(stop_busstop_id);


//                Date currentTime = Calendar.getInstance().getTime();
//                Log.d(TAG, "Location: " + location.getLatitude() + " " + location.getLongitude()+" "+location.getTime()+" "+currentTime);

            }


        }




    };

    public void addAllBusStop() {

        DatabaseReference ref2 = FirebaseDatabase.getInstance().getReference("active_bus/" + user_id + "/busstop");
        ref2.removeValue();


        for (int i = 0; i < bus_stop.length; i++) {
            final String path = "active_bus/" + user_id + "/busstop/" + i + "/" + bus_stop[i];
            DatabaseReference ref = FirebaseDatabase.getInstance().getReference(path);
            ref.child("on_busstop_status").setValue(false);
            ref.child("path_status").setValue(false);

            //if path status is true that mean bus pass this path
        }

    }


    @Override
    public void onConnected(@Nullable Bundle bundle) {
//        requestLocationUpdates();
//        Log.d(TAG, "Google Api Client Connected");
//        isMonitoring = true;
//        //        startGeofencing();


        //////////////////////////////////////////////

        if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            // TODO: Consider calling
            //    ActivityCompat#requestPermissions
            // here to request the missing permissions, and then overriding
            //   public void onRequestPermissionsResult(int requestCode, String[] permissions,
            //                                          int[] grantResults)
            // to handle the case where the user grants the permission. See the documentation
            // for ActivityCompat#requestPermissions for more details.
            return;
        }
        LocationAvailability locationAvailability = LocationServices.FusedLocationApi.getLocationAvailability(mGoogleApiClient);
        if (locationAvailability.isLocationAvailable()) {
            // Call Location Services
            Log.d(TAG, "Google Api Client Connected");
            LocationRequest locationRequest = new LocationRequest()
                    .setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY)
                    .setInterval(100000);
            LocationServices.FusedLocationApi.requestLocationUpdates(mGoogleApiClient, locationRequest, this);
        } else {
            // Do something when Location Provider not available
        }

    }

    @Override
    public void onConnectionSuspended(int i) {

    }

    @Override
    public void onConnectionFailed(@NonNull ConnectionResult connectionResult) {

        isMonitoring = false;

    }

    @Override
    public void onLocationChanged(Location location) {

        final String path = "active_bus/" + user_id;
        DatabaseReference ref = FirebaseDatabase.getInstance().getReference(path);
        ref.child("lat").setValue(location.getLatitude());
        ref.child("lng").setValue(location.getLongitude());

        Calendar c = Calendar.getInstance();
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String formattedDate = df.format(c.getTime());

        ref.child("time").setValue(formattedDate);
        ref.child("bus_id").setValue(bus_id);

        ref.child("destination").setValue(destination);
        ref.child("start_busstop_id").setValue(start_busstop_id);
        ref.child("stop_busstop_id").setValue(stop_busstop_id);

        Log.d(TAG, "onLocationChanged: "+location.getLatitude()+" "+location.getLongitude());

    }
}
